% This script is used by the randomizer script to generate a test harness
% for the model. The harness model is used as a template. The connections
% are automatically made for the model.
% This is done to avoid changes made to the harness also by the script and
% avoid complicated code.

% (c) Prasad K <k14prasad@gmail.com>

% This uses the copy contents function to copy the Model subsystems along 
% with the mutations into the harness model.
 
delete 'temp.mdl';
open_system(['Duplicate' num2str(runs  - 1 )]);
bdclose temp
new_system('temp','Model',['Duplicate' num2str(runs  - 1 ) '/Model']);
save_system('temp');
load_system('Harness');
Simulink.BlockDiagram.copyContentsToSubSystem('temp', 'Harness/Model');
delete 'temp.mdl';

% Connect the inputs
for i = 1:10
    add_line('Harness',['Demux/' num2str(i)],['Model/' num2str(i)]);
end

% Connect the outputs
for i = 1:7
    add_line('Harness',['Model/' num2str(i)],['Mux/' num2str(i)]);
end

close_system(['Duplicate' num2str(runs  - 1 )],0);
save_system('Harness',['Duplicate' num2str(runs  - 1 )]);
close_system('Harness',0);
