% The Benchmark Problem 001 Code with Coverage

% (c) Yogananda Jeppu yvj_2000@yahoo.com

% Initialize all variables
ppdf01 = 0;
pdf01 = 0;
pposat0 = 0;
posat0 = 0;
ppdf02 = 0;
pdf02 = 0;
pposat1 = 0;
posat1 = 0;
pofil2 = 0;
posat2 = 0;
pout2 = 0;
pout5 = 0;
ppofil3 = 0;
pofil3 = 0;
pposat4 = 0;
posat4 = 0;
pout7=0;
pointeg2 = 0;
pinro1 = 0;inro1 = 0;
posat3 = 0;
DtOn = 100;
DtOff = 200;
pinper1 = 0; count=0; outper=0;init=1;
pininteg1=0;
posat6 = 0;

% Initialize the output vector and a temporary tapout variable
OUT = zeros(length(t),7);
TEMP=zeros(length(t),5);

% Data of the filters
NZ1=[3.951007506914264e-004    7.902015013828528e-004    3.951007506914264e-004];
DZ1=[1.000000000000000e+000   -1.974713551955749e+000    9.762939549585143e-001];
NZ2=[1.536098310291859e-003    3.072196620583717e-003    1.536098310291859e-003];
DZ2=[1.000000000000000e+000   -1.917050691244239e+000    9.231950844854068e-001];
NZ3=[9.090909090909092e+000   -9.090909090909092e+000];
DZ3=[1.000000000000000e+000   -8.181818181818182e-001];
NZ4=[3.462870334744132e-003    6.925740669488265e-003    3.462870334744132e-003];
DZ4=[1.000000000000000e+000   -1.916891111966141e+000    9.307425933051174e-001];
Ts=0.02;  % Sample Time used in computation (same as DT)
delaytemp = [0 0 0 0];  % Initialize delay

% Table lookup data
XT=[-170 -100 -50 25 30 100];
YT=[10 20 30 40 50 60];
COVERAGE = zeros(1,76);
cond1 = [0 0 0 0 0 0 0 0];
cond2 = [0 0 0 0];
% Start iterattions
for ii = 1:length(t)
    icoverage=1;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    % Assign Inputs taken put from the simulink model
    inp1 = INP1(ii);
    inp2 = INP2(ii);
    inp3 = INP3(ii);
    inp4 = INP4(ii);
    inp5 = INP5(ii);
    inp6 = INP6(ii);
    inp7 = INP7(ii);
    inp8 = INP8(ii);
    inp9 = INP9(ii);
    inp10 = INP10(ii);
    
    % Saturation Block OSAT0
    if (inp1 < -60)
        osat0 = -60;
        icoverage=2;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    elseif (inp1 > 60)
        osat0 = 60;
        icoverage=3;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    else
        osat0 = inp1;
        icoverage=4;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    end
    % Saturation Block OSAT1
    icoverage=5;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    if (inp2 < -60)
        osat1 = -60;
        icoverage=6;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    elseif (inp2 > 60)
        osat1 = 60;
        icoverage=7;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    else
        osat1 = inp2;
        icoverage=8;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    end
    
    % Discrete Filter
    icoverage=9;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    df01 = NZ1(1)*osat0+NZ1(2)*posat0+NZ1(3)*pposat0-DZ1(2)*pdf01-DZ1(3)*ppdf01;
    ppdf01=pdf01;
    pdf01=df01;
    pposat0=posat0;
    posat0=osat0;
    
    %Discrete Filter1
    df02 = NZ2(1)*osat1+NZ2(2)*posat1+NZ2(3)*pposat1-DZ2(2)*pdf02-DZ2(3)*ppdf02;
    ppdf02=pdf02;
    pdf02=df02;
    pposat1=posat1;
    posat1=osat1;
    
    %Adder Block
    inlook01=df01-df02;
    
    % Interpolation
    icoverage=10;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    COVI=COVERAGE(11:17);
    [out1,COVI]=interpol1(XT,YT,inlook01,COVI);
    COVERAGE(11:17) = COVI;
    
    % Saturation osat2
    if (inp3 < -20)
        osat2 = -20;
        icoverage=18;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    elseif (inp3 > 10)
        osat2 = 10;
        icoverage=19;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    else
        osat2 = inp3;
        icoverage=20;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    end
    icoverage=21;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    %Discrete Filter 2
    ofil2 = NZ3(1)*osat2+NZ3(2)*posat2-DZ3(2)*pofil2;
    pofil2=ofil2;
    posat2=osat2;
    
    
    % Saturation Block osat3
    if (ofil2 < -5)
        osat3 = -5;
        icoverage=22;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    elseif (ofil2 > 5)
        osat3 = 5;
        icoverage=23;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    else
        osat3 = ofil2;
        icoverage=24;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    end
    
    % Discrete Integrator with Limits
    out2 = posat3*Ts+pout2;
    icoverage=25;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    if out2 > 30
        out2 = 30;
        icoverage=26;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    elseif out2 < -30
        out2 = -30;
        icoverage=27;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    end
    icoverage=28;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    pout2=out2;
    posat3 = osat3;
    
    % Xor Logic
    
    xorout = xor(xor(inp6,not(inp8)),inp9);
    inpcond = [inp6 not(inp8) inp9];
    cond1 = concover(cond1,inpcond);

    % Saturation Block osat5
    if (inp5 < -3.5)
        osat5 = -3.5;
        icoverage=29;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    elseif (inp5 > 3.5)
        osat5 = 3.5;
        icoverage=30;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    else
        osat5 = inp5;
        icoverage=31;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    end
    
    % Switch
    if (xorout)
        ininteg1 = osat5;
        icoverage=32;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    else
        ininteg1 = -1;
        icoverage=33;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    end
    
    % Discrete Integrator1 with Limits
    out5 = pininteg1*Ts+pout5;
    icoverage=34;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    if out5 > 10
        out5 = 10;
        icoverage=35;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    elseif out5 < -10
        out5 = -10;
        icoverage=36;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    end
    icoverage=37;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    pout5=out5;
    pininteg1=ininteg1;
    
    % Saturation Block osat4
    if (inp4 < -40)
        osat4 = -40;
        icoverage=38;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    elseif (inp4 > 40)
        osat4 = 40;
        icoverage=39;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    else
        osat4 = inp4;
        icoverage=40;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    end
    
    % Discrete Filter 3
    icoverage=41;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    ofil3 = NZ4(1)*osat4+NZ4(2)*posat4+NZ4(3)*pposat4-DZ4(2)*pofil3-DZ4(3)*ppofil3;
    ppofil3=pofil3;
    pofil3=ofil3;
    pposat4=posat4;
    posat4=osat4;
    
    % Addrer Block
    oadd1 = out5 + ofil3;
    
    % Relational operator
    if oadd1 >= 70
        out3 = 1;
        icoverage=42;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    else
        out3 = 0;
        icoverage=43;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    end
    
    % Rate Limiter Dynamic 1
    icoverage=44;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    ul = 10*Ts;
    ll = -10*Ts;
    itemp = inp7-pout7;
    if itemp > ul
        out7 = ul+pout7;
        icoverage=45;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    elseif itemp < ll
        out7 = pout7+ll;
        icoverage=46;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    else
        out7 = pout7+itemp;
        icoverage=47;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    end
    pout7 = out7;
    icoverage=48;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    
    % Delay 4 samples
    delayo = delaytemp(1);
    for i = 1:3
        delaytemp(i) = delaytemp(i+1);
        icoverage=49;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    end
    delaytemp(4) = out7;
    icoverage=50;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    
    % Add2
    inro2 = delayo - out7;
    
    % Relational operator 2
    oro2 = (inro2 >= 0.6);
    
    % % Relational operator 3
    oro3 = ( out7 < -80 );
    
    % AND block
    out4 = and(oro3,oro2);
    inpcond = [oro3,oro2];
    cond2 = concover(cond2,inpcond);

    % Saturation Block osat6
    if (inp10 < -100)
        osat6 = -100;
        icoverage=51;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    elseif (inp10 > 100)
        osat6 = 100;
        icoverage=52;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    else
        osat6 = inp10;
        icoverage=53;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    end
    
    % Discrete Integrator
    icoverage=54;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    ointeg2 = posat6*Ts+pointeg2;
    pointeg2=ointeg2;
    posat6=osat6;
    
    % Hysterisis
    bw=100;
    if ointeg2 > (pinro1 +bw/2)
        inro1 = ointeg2-(bw/2);
        icoverage=55;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    elseif ointeg2 < (pinro1 -bw/2)
        inro1 = ointeg2+(bw/2);
        icoverage=56;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    end
    pinro1 = inro1 ;
    icoverage=57;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    
    % Relational Operator 1
    inper1 = (inro1 >= 250);
    
    % Peristence
    if (inper1)
        dtx = DtOn;
        icoverage=58;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    else
        dtx = DtOff;
        icoverage=59;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    end
    
    if inper1~=pinper1
        count=0;
        icoverage=60;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    end
    count = count+1;
    icoverage=61;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    if count > dtx
        outper = inper1;
        icoverage=62;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    end
    if init == 1
        outper = 0;
        count = 1;
        init = 0;
        icoverage=63;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    end
    
    pinper1=inper1;
    % TEMP(ii,1) = ;
    % TEMP(ii,2) = osat3;
    
    out6 = outper;
    
    % Tap out all the outputs
    OUT(ii,:) = [out1 out2 out3 out4 out5 out6 out7];
    icoverage=64;COVERAGE(icoverage)=COVERAGE(icoverage)+1;
    COVERAGE(65:72) = cond1;
    COVERAGE(73:76) = cond2;
end

% End of iterations

% plot(t,OUT(:,1)-simout1);shg;pause
% plot(t,OUT(:,2)-simout2);shg;pause
% plot(t,OUT(:,3)-simout3);shg;pause
% plot(t,OUT(:,4)-simout4);shg;pause
% plot(t,OUT(:,5)-simout5);shg;pause
% plot(t,OUT(:,6)-simout6);shg;pause
% plot(t,OUT(:,7)-simout7);shg;pause

plot(t,OUT-[simout1 simout2 simout3 simout4 simout5 simout6 simout7]);shg

% Compute Error between model and matlab
err=max(max(abs(OUT-[simout1 simout2 simout3 simout4 simout5 simout6 simout7])));
if err > 0.0000001
    disp(err)
    pause
end
pause(1)